grammar Opcodes ;

file : instruction+;

instruction : INAME ':' ICODE '\r'? '\n'
            | INAME ':' ICODE
            ;

// Fragements
fragment BIT      : '0' .. '1';
fragment DIGIT    : '0' .. '9';
fragment UPPER    : 'A' .. 'Z';
fragment LOWER    : 'a' .. 'z';
fragment LETTER   : LOWER | UPPER;
fragment WORD     : LETTER | '_' | '$' | '#' | '.';
fragment ALPHANUM : WORD | DIGIT;

// Tokens
INAME   : LETTER ALPHANUM*;
ICODE   : BIT BIT? BIT? BIT? BIT? BIT? BIT? BIT?;

WS  : [ \t\n\r]+ -> skip ;