import org.antlr.v4.runtime.misc.NotNull;

import java.util.*;

/**
 * @author Karl Janson
 * @since 11/23/14
 */
public class InstrLoader extends OpcodesBaseListener {

    /**
     * Map for storing the instruction list.
     */
    private Map<String, String> intructionList =
            new TreeMap<String, String>(String.CASE_INSENSITIVE_ORDER);

    @Override
    public void exitInstruction(@NotNull OpcodesParser.InstructionContext ctx) {
        super.exitInstruction(ctx);
        intructionList.put(ctx.INAME().getText(), ctx.ICODE().getText());
    }

    /**
     * Returns the instructions list.
     * @return instruction list
     */
    public Map<String, String> getInstructionList() {
        return intructionList;
    }
}
